/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#include "move.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gprintf.h>

void moveToString(Move move, gchar string[6]){
	gchar square[3];
	gint promotion;
	string[0] = '\0';
	squareToString(moveGetFrom(move),square);
	strcat(string,square);
	squareToString(moveGetTo(move),square);
	strcat(string,square);
	promotion = moveGetPromotion(move);
	switch(promotion){
		case WHITE_QUEEN:  case BLACK_QUEEN:  { string[4] = 'q'; break; }
		case WHITE_ROOK:   case BLACK_ROOK:   { string[4] = 'r'; break; }
		case WHITE_BISHOP: case BLACK_BISHOP: { string[4] = 'b'; break; }
		case WHITE_KNIGHT: case BLACK_KNIGHT: { string[4] = 'n'; break; }
	};
	string[5] = '\0';
}

void movesToString(Move move[], gchar string[]){
	guint index = 0;
	gchar smove[6];
	string[0] = '\0';
	while(move[index] != 0){
		moveToString(move[index], smove);
		if(index % 2 == 0)
			sprintf(string,"%s\t%d. %s\t",string,(index/2)+1,smove);
		else
			sprintf(string,"%s%s\n",string,smove);
		index++;
	}
}

void movePrint(Move move){
    gchar string[6], square[3];
	gint promotion;
	string[0] = '\0';
	squareToString(moveGetFrom(move),square);
	strcat(string,square);
	squareToString(moveGetTo(move),square);
	strcat(string,square);
	promotion = moveGetPromotion(move);
	switch(promotion){
		case WHITE_QUEEN:  case BLACK_QUEEN:  { string[4] = 'q'; break; }
		case WHITE_ROOK:   case BLACK_ROOK:   { string[4] = 'r'; break; }
		case WHITE_BISHOP: case BLACK_BISHOP: { string[4] = 'b'; break; }
		case WHITE_KNIGHT: case BLACK_KNIGHT: { string[4] = 'n'; break; }
	};
	string[5] = '\0';
	g_printf("%s",string);
}

void movePrintPV(Move move[]){
	gchar smove[6];
	gint index = 0;
	while(move[index] != 0){
		moveToString(move[index], smove);
		g_printf("%s ",smove);
		index++;
	}
}
